/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ConnectEntryPointCommand.cs,v 1.10 2003/04/25 03:06:04 hoge-taicho Exp $
 * 
 */

using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;

using Zigumo.Model;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// Gg[|CgڑR}h
	/// ̃R}hɂGg[|Cgւ̐ڑs
	/// </summary>
	public class ConnectEntryPointCommand : Zigumo.CommandObject.ControllerCommand
	{
		public ConnectEntryPointCommand()
		{
		}

		/// <summary>
		/// R}hs鏈
		/// </summary>
		public override void Execute() {
			model.Log.Write("Connect EntryPoint " + model.EntryPointAddress);

			//Xe[^Xo[XV
			SetStatusBarDelegate setStatusBarDelegate = new SetStatusBarDelegate(commandController.Form.SetStatusBar);
			object[] obj = { "Gg[|Cgڑ..." };
			commandController.Form.BeginInvoke(setStatusBarDelegate, obj);

			//HTTPNGXg̍쐬
			string url = model.EntryPointAddress + "?port=" + model.PortNumber.ToString();
			HttpWebRequest httpReq = (HttpWebRequest)HttpWebRequest.Create(url);
			httpReq.UserAgent = model.ZigumoUserAgent;
			HttpWebResponse httpRes = (HttpWebResponse)httpReq.GetResponse();
			
			//Xg[oRŎ擾
			Stream st = httpRes.GetResponseStream();
			StreamReader sr = new StreamReader(st, Encoding.GetEncoding("Shift_JIS"));
			
			//擾ʃp[X
			int count = 0;
			string line;
			while((line = sr.ReadLine()) != null) {
				int start = line.IndexOf(" ", line.IndexOf(" ") + 1) + 1;
				int start2 = line.IndexOf(":", start);
				string dateTime = line.Substring(0, start);
				string ipAddress = line.Substring(start, start2 - start);
				int portNumber = Convert.ToInt32(line.Substring(start2 + 1));
				if(count++ == 0) {//ŏɑĂPs͎̃f[^Ȃ̂ŁAʏ
					model.IPAddress = IPAddress.Parse(ipAddress);
					model.PortNumber = portNumber;

					model.Log.Write("Reflect my IPAddress " + model.IPAddress.ToString() + ":" + model.PortNumber.ToString());
				} else {//ȊO̓T[ogXgɒǉ
					connectionManager.AddServentInfo(new Servent(IPAddress.Parse(ipAddress), portNumber, DateTime.Parse(dateTime)));

					//擾IPAhX̃XgOƂĕ\
					model.Log.Write("Get IPAddress " + ipAddress.ToString() + ":" + portNumber.ToString());
				}
			}
			sr.Close();
			st.Close();

			//Xe[^Xo[NA
			obj[0] = "";
			commandController.Form.BeginInvoke(setStatusBarDelegate, obj);

			//擾IPAhXփnhVFCNJn
            connectionManager.HandShake();
		}
	}
}
