/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ReceiveQueryChatCommand.cs,v 1.4 2003/04/25 03:06:04 hoge-taicho Exp $
 * 
 */

using System;
using System.Text;

using Zigumo.MessageObject;
using Zigumo.Network;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// queryChatR}h
	/// </summary>
	public class ReceiveQueryChatCommand : Zigumo.CommandObject.ControllerCommand
	{
		/// <summary>
		/// ̃R}h𔭍sP2PRlNVւ̎Q
		/// </summary>
		private P2PConnection p2pConnection;
		/// <summary>
		/// MbZ[W
		/// </summary>
		private QueryChatMessage queryChat;

		public ReceiveQueryChatCommand(P2PConnection p2pCon, QueryChatMessage msg) {
			p2pConnection = p2pCon;
			queryChat = msg;
		}
		/// <summary>
		/// queryChatbZ[WMꍇ͎̕@ɂďs
		/// 1.MqueryChatbZ[WƓIDLbVɂ邩ǂ
		/// 2.ꍇ́AbZ[WjB
		/// 3.Ȃꍇ́AqueryChat̓eāAYꍇ̂݁AqueryChat𑗂ĂT[ogqueryChatHitԐM
		/// 4.queryChatbZ[W𑗂ĂT[ogȊOɒp
		/// </summary>
		public override void Execute() {
			if(queryChat.TTL == 0)//TTLɃ[Ȃ珈Ȃ
				return;

			//ɎMƂ̂郁bZ[WǂALbV`FbN閳ꍇ͎MqueryChatLbVɓo^
			ConnectionManager.MessageCacheData msgCacheData = (ConnectionManager.MessageCacheData)connectionManager.PutCache(queryChat.MessageIDToGuid, new ConnectionManager.MessageCacheData(queryChat.Type, p2pConnection.ID));
			if(msgCacheData == null) {//xMĂȂꍇAqueryChatbZ[W

				//`bgT[oƂĉғĂ邩
				if(model.ChatServer) {
					//`bgT[oƂĉғĂꍇAqueryChatHitԐM
					QueryChatHitMessage queryChatHit = new QueryChatHitMessage(Zigumo.MessageObject.Message.headerSize +
						QueryChatHitMessage.basePayloadSize + model.ChatCategory.CategoryID.Length);
					queryChatHit.CreateHeader();
					queryChatHit.PayloadSize = QueryChatHitMessage.basePayloadSize + model.ChatName.Length;
					queryChatHit.Port = model.PortNumber;
					queryChatHit.Address = model.IPAddress;
					queryChatHit.ServentIDToGuid = model.ServentID;
					queryChatHit.ChatNumber = model.ChatNumber;
					queryChatHit.ChatMaxNumber = model.ChatMaxNumber;
					queryChatHit.ChatName = Encoding.Unicode.GetBytes(model.ChatName);

					connectionManager.SendMessage(queryChatHit, p2pConnection, true);//MR}hs
					
				}

				//TTLfNgTTL>0̏ꍇ̓bZ[W𒆌p
				queryChat.TTL--;
				queryChat.Hops++;
				if(queryChat.TTL > 0) {//TTL>0̏ꍇ̂݃bZ[W𒆌p
					//bZ[Wp
					connectionManager.SendMessage(queryChat, p2pConnection, false);//bZ[WMȊOɃu[hLXg
				}
			
			}
		}//end Execute


	}
}
