/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ChatConfigDialog.cs,v 1.4 2003/04/25 03:06:20 hoge-taicho Exp $
 * 
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Zigumo.Model;

namespace Zigumo.DialogObject
{
	/// <summary>
	/// ChatConfigDialog ̊Tv̐łB
	/// </summary>
	public class ChatConfigDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;
		private System.Windows.Forms.TextBox chatName;
		private System.Windows.Forms.CheckBox chatServer;
		private System.Windows.Forms.TextBox chatMaxNumber;
		private System.Windows.Forms.TextBox chatCategory;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button choiceButton;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public BbsCategory ChatCategory {
			get {
				return (BbsCategory)chatCategory.Tag;
			}
			set {
				chatCategory.Tag = value;
			}
		}
		/// <summary>
		/// `bg[̃vpeB
		/// </summary>
		public string ChatName {
			get {
				return chatName.Text;
			}
			set {
				chatName.Text = value;
			}
		}
		/// <summary>
		/// `bgQl̃vpeB
		/// </summary>
		public int ChatMaxNumber {
			get {
				return Int32.Parse(chatMaxNumber.Text);
			}
			set {
				chatMaxNumber.Text = value.ToString();
			}
		}
		/// <summary>
		/// `bgT[őNԂ̃vpeB
		/// </summary>
		public bool ChatServer {
			get {
				return chatServer.Checked;
			}
			set {
				chatServer.Checked = value;
			}
		}

		public ChatConfigDialog()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.chatName = new System.Windows.Forms.TextBox();
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.chatServer = new System.Windows.Forms.CheckBox();
			this.chatMaxNumber = new System.Windows.Forms.TextBox();
			this.chatCategory = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.choiceButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 62);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			this.label1.Text = "`bg[";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 120);
			this.label2.Name = "label2";
			this.label2.TabIndex = 1;
			this.label2.Text = "őQl";
			// 
			// chatName
			// 
			this.chatName.Location = new System.Drawing.Point(16, 80);
			this.chatName.Name = "chatName";
			this.chatName.Size = new System.Drawing.Size(200, 19);
			this.chatName.TabIndex = 0;
			this.chatName.Text = "";
			// 
			// okButton
			// 
			this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.okButton.Location = new System.Drawing.Point(31, 176);
			this.okButton.Name = "okButton";
			this.okButton.TabIndex = 3;
			this.okButton.Text = "OK";
			// 
			// cancelButton
			// 
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(127, 176);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.TabIndex = 4;
			this.cancelButton.Text = "LZ";
			// 
			// chatServer
			// 
			this.chatServer.Location = new System.Drawing.Point(16, 144);
			this.chatServer.Name = "chatServer";
			this.chatServer.Size = new System.Drawing.Size(160, 24);
			this.chatServer.TabIndex = 2;
			this.chatServer.Text = "`bgT[oN";
			// 
			// chatMaxNumber
			// 
			this.chatMaxNumber.Location = new System.Drawing.Point(114, 112);
			this.chatMaxNumber.Name = "chatMaxNumber";
			this.chatMaxNumber.TabIndex = 1;
			this.chatMaxNumber.Text = "";
			// 
			// chatCategory
			// 
			this.chatCategory.Location = new System.Drawing.Point(16, 32);
			this.chatCategory.Name = "chatCategory";
			this.chatCategory.ReadOnly = true;
			this.chatCategory.Size = new System.Drawing.Size(200, 19);
			this.chatCategory.TabIndex = 5;
			this.chatCategory.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 14);
			this.label3.Name = "label3";
			this.label3.TabIndex = 6;
			this.label3.Text = "`bgJeS";
			// 
			// choiceButton
			// 
			this.choiceButton.Location = new System.Drawing.Point(152, 8);
			this.choiceButton.Name = "choiceButton";
			this.choiceButton.Size = new System.Drawing.Size(64, 24);
			this.choiceButton.TabIndex = 7;
			this.choiceButton.Text = "I...";
			this.choiceButton.Click += new System.EventHandler(this.choiceButton_Click);
			// 
			// ChatConfigDialog
			// 
			this.AcceptButton = this.okButton;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.CancelButton = this.cancelButton;
			this.ClientSize = new System.Drawing.Size(232, 216);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.choiceButton,
																		  this.chatCategory,
																		  this.label3,
																		  this.chatMaxNumber,
																		  this.chatServer,
																		  this.cancelButton,
																		  this.okButton,
																		  this.chatName,
																		  this.label2,
																		  this.label1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ChatConfigDialog";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "ChatConfigDialog";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// JeSI{^ꂽꍇ
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void choiceButton_Click(object sender, System.EventArgs e) {
			ChoiceCategoryTreeDialog dlg = new ChoiceCategoryTreeDialog();

			if(dlg.ShowDialog() == DialogResult.OK) {
				BbsCategory category = dlg.SelectedCategory;
				if(category != null) {
					chatCategory.Tag = category;
					chatCategory.Text = category.Name;
					//test
					Console.WriteLine(category.CategoryID);
				}
			}//end if
		}//end choiceButton_Click

	}
}
