/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: PingMessage.cs,v 1.4 2003/04/25 03:06:38 hoge-taicho Exp $
 * 
 */

using System;

namespace Zigumo.MessageObject
{
	/// <summary>
	/// pingbZ[W
	/// f[^{́Bȉ̃f[^\B
	/// 0-15	16	bZ[WIDiGuidj
	/// 16		 1	Description(int)
	/// 17		 1	TTL(int)
	/// 18		 1	Hops(int)
	/// 19-22	 4	yC[hTCY(int)
	/// ------------------------------------
	/// 23-24	 2	|[gԍ(int)
	/// 25-28	 4	IPAhX(IPAddress)
	/// 29-32	 4	Xbh(int)
	/// 33		 1	T[ogXe[^X(int)
	/// </summary>
	public class PingMessage : Zigumo.MessageObject.Message {
		public PingMessage() : this(Message.headerSize) {
		}

		public PingMessage(int length) : base(length) {
		}

		public PingMessage(byte[] data) : base(data) {
		}

		/// <summary>
		/// wb_[\bh
		/// </summary>
		public override void CreateHeader() {
			base.CreateHeader();
			this.Type = (byte)MessageType.Ping;
			this.PayloadSize = 0;
		}

		/// <summary>
		/// bZ[W̖OԂ\bh
		/// </summary>
		/// <returns>bZ[W</returns>
		public override string ToString() {
			return "Ping";
		}
	}
}
