/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: BbsCategoryTabPage.cs,v 1.9 2003/04/27 18:44:51 hoge-taicho Exp $
 * 
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Threading;
using System.Windows.Forms;

using Zigumo.Model;

namespace Zigumo.View
{
	/// <summary>
	/// BbsCategoryTabPage ̊Tv̐łB
	/// </summary>
	public class BbsCategoryTabPage : System.Windows.Forms.TabPage
	{
		private ZigumoModel model;
		private ZigumoForm form;

		/// <summary>
		/// ݂̃^uƊ֘AtĂBbsCategoryւ̎Q
		/// </summary>
		private BbsCategory category;
		/// <summary>
		/// ̃^uXVĂXbhւ̎Q
		/// </summary>
		private Thread thread;
		/// <summary>
		/// ̃^uQ̃XbhXgzigumõXbhXgB
		/// </summary>
		private BbsType bbsType;

//pending
//private ListViewEx listView;
		private System.Windows.Forms.ListView listView;
		private System.Windows.Forms.ColumnHeader markHeader;
		private System.Windows.Forms.ColumnHeader numberHeader;
		private System.Windows.Forms.ColumnHeader titleHeader;
		private System.Windows.Forms.ColumnHeader resnumHeader;
		private System.Windows.Forms.ColumnHeader lastUpdateHeader;
		private System.Windows.Forms.ColumnHeader startDateHeader1;
		private System.Windows.Forms.ColumnHeader categoryHeader;
		private System.Windows.Forms.ColumnHeader idHeader;
		private System.Windows.Forms.ColumnHeader lastResnumHeader;
		private System.Windows.Forms.ContextMenu bbsThreadListMenu;
		private System.Windows.Forms.MenuItem openNewTabPageMenu;
		private System.Windows.Forms.ImageList threadStatusImageList;
		private System.ComponentModel.IContainer components;

		/// <summary>
		/// ݂̃^uƊ֘AtĂBbsCategorỹvpeB
		/// </summary>
		public BbsCategory BbsCategory {
			get {
				return category;
			}
			set {
				category = value;
			}
		}

		/// <summary>
		/// ̃^uXVĂXbhւ̎Q
		/// </summary>
		public Thread Thread {
			get {
				return thread;
			}
			set {
				thread = value;
			}
		}
		
		/// <summary>
		/// Xgr[̃vpeB
		/// </summary>
		public ListView ListView {
			get {
				return listView;
			}
			set {
				listView = value;
			}
		}

		/// <summary>
		/// ̃^uQzigumo\vpeB
		/// </summary>
		public BbsType BbsType {
			get {
				return bbsType;
			}
			set {
				bbsType = value;
			}
		}

		public BbsCategoryTabPage(ZigumoForm form, BbsType type) : base()
		{
			this.form = form;
			model = ZigumoModel.Model;

			//^Cv̐ݒiQzigumoj
			this.bbsType = type;
			this.ImageIndex = (int)type;

			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();

			ClearListView();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(BbsCategoryTabPage));
			this.listView = new System.Windows.Forms.ListView();
			this.markHeader = new System.Windows.Forms.ColumnHeader();
			this.numberHeader = new System.Windows.Forms.ColumnHeader();
			this.titleHeader = new System.Windows.Forms.ColumnHeader();
			this.resnumHeader = new System.Windows.Forms.ColumnHeader();
			this.lastResnumHeader = new System.Windows.Forms.ColumnHeader();
			this.lastUpdateHeader = new System.Windows.Forms.ColumnHeader();
			this.startDateHeader1 = new System.Windows.Forms.ColumnHeader();
			this.categoryHeader = new System.Windows.Forms.ColumnHeader();
			this.idHeader = new System.Windows.Forms.ColumnHeader();
			this.threadStatusImageList = new System.Windows.Forms.ImageList(this.components);
			this.bbsThreadListMenu = new System.Windows.Forms.ContextMenu();
			this.openNewTabPageMenu = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// listView
			// 
			this.listView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					   this.markHeader,
																					   this.numberHeader,
																					   this.titleHeader,
																					   this.resnumHeader,
																					   this.lastResnumHeader,
																					   this.lastUpdateHeader,
																					   this.startDateHeader1,
																					   this.categoryHeader,
																					   this.idHeader});
			this.listView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView.FullRowSelect = true;
			this.listView.HideSelection = false;
			this.listView.MultiSelect = false;
			this.listView.Name = "listView";
//pending
//			this.listView.NumericalSortColumns = ((System.Collections.ArrayList)(resources.GetObject("listView.NumericalSortColumns")));
			this.listView.Size = new System.Drawing.Size(200, 100);
			this.listView.SmallImageList = this.threadStatusImageList;
			this.listView.TabIndex = 0;
			this.listView.View = System.Windows.Forms.View.Details;
			this.listView.Click += new System.EventHandler(this.listView_Click);
			this.listView.SelectedIndexChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
			this.listView.MouseUp += new System.Windows.Forms.MouseEventHandler(this.listView_MouseUp);
			// 
			// markHeader
			// 
			this.markHeader.Text = "!";
			this.markHeader.Width = 18;
			// 
			// numberHeader
			// 
			this.numberHeader.Text = "No.";
			this.numberHeader.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numberHeader.Width = 48;
			// 
			// titleHeader
			// 
			this.titleHeader.Text = "^Cg";
			this.titleHeader.Width = 256;
			// 
			// resnumHeader
			// 
			this.resnumHeader.Text = "X";
			this.resnumHeader.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.resnumHeader.Width = 48;
			// 
			// lastResnumHeader
			// 
			this.lastResnumHeader.Text = "";
			this.lastResnumHeader.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.lastResnumHeader.Width = 48;
			// 
			// lastUpdateHeader
			// 
			this.lastUpdateHeader.Text = "ŏIXV";
			// 
			// startDateHeader1
			// 
			this.startDateHeader1.Text = "쐬";
			// 
			// categoryHeader
			// 
			this.categoryHeader.Text = "JeS";
			// 
			// idHeader
			// 
			this.idHeader.Text = "ID";
			// 
			// threadStatusImageList
			// 
			this.threadStatusImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.threadStatusImageList.ImageSize = new System.Drawing.Size(16, 12);
			this.threadStatusImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("threadStatusImageList.ImageStream")));
			this.threadStatusImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// bbsThreadListMenu
			// 
			this.bbsThreadListMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							  this.openNewTabPageMenu});
			// 
			// openNewTabPageMenu
			// 
			this.openNewTabPageMenu.Index = 0;
			this.openNewTabPageMenu.Text = "V^uŊJ";
			this.openNewTabPageMenu.Click += new System.EventHandler(this.openNewTabPageMenu_Click);
			// 
			// BbsCategoryTabPage
			// 
			this.ContextMenu = this.bbsThreadListMenu;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.listView});
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Xgr[NA\bh
		/// </summary>
		public void ClearListView() {
			this.listView.Items.Clear();
		}
		
		/// <summary>
		/// XbhXgXVB
		/// </summary>
		public void UpdateCategoryTabView(BbsThread bbsThread, Thread thread) {
			lock(this) {
				if(this.thread == thread)//ǂ̃XbhR}hƊ֘AtĂ邩`FbNĂ珑
					this.listView.Items.Add(bbsThread.GetListViewItem());
			}
		}

		/// <summary>
		/// w肳ꂽACeXV
		/// </summary>
		/// <param name="bbsThread">XVXbh</param>
		public void UpdateItem(BbsThread bbsThread) {
			foreach(ListViewItem item in listView.Items) {
				if(item.SubItems[(int)Column.ID].Text == bbsThread.ThreadID) {
					item.SubItems[(int)Column.LastResnum].Text = ((int)(bbsThread.CurrentResNum - 1)).ToString();
					item.ImageIndex = 0;//`FbN}[NACRɕ\ؑ
				}
			}
		}
		
		/// <summary>
		/// Xbh\
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void listView_Click(object sender, System.EventArgs e) {
		}

		private void listView_SelectedIndexChanged(object sender, System.EventArgs e) {
		
		}

		/// <summary>
		/// V^uŊJꍇ̃j[
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void openNewTabPageMenu_Click(object sender, System.EventArgs e) {
			//Xbh\p^uJ
			BbsThreadTabPage bbsThreadTabPage = new BbsThreadTabPage();
			form.BbsThreadTabView.TabPages.Add(bbsThreadTabPage);
			form.BbsThreadTabView.SelectedTab = bbsThreadTabPage;

			//IꂽXbh擾
			ListViewItem item = this.listView.SelectedItems[0];
			if(item != null) {
				BbsThread bbsThread = (BbsThread)item.Tag;
				if(bbsThread != null) {
					OpenBbsThread(bbsThread);
				}
			}
		}

		/// <summary>
		/// XbhIꂽꍇ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void listView_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e) {
			if(e.Button == MouseButtons.Left) {
				ListViewItem item = (ListViewItem)this.listView.GetItemAt(e.X, e.Y);

				if(item != null) {
					BbsThread bbsThread = (BbsThread)item.Tag;
					if(bbsThread != null) {
						OpenBbsThread(bbsThread);
					}
				}
			}
		}//end listView_MouseUp

		/// <summary>
		/// XbhJ
		/// </summary>
		private void OpenBbsThread(BbsThread bbsThread) {
			//ݑIĂXbh^u擾
			BbsThreadTabPage bbsThreadTabPage = form.SelectedBbsThreadTapPage;

			bbsThread.TabPage = bbsThreadTabPage;//\̃^uݒ
			form.BbsThreadTitleLabel = bbsThread.Title;
			bbsThreadTabPage.Text = bbsThread.Title;
			bbsThread.UpdateThread();//\eXV
		}

		/// <summary>
		/// `XV̒~(ACe}OɎsĂׂ)
		/// </summary>
		public void BeginUpdate()
		{
			this.listView.BeginUpdate();
		}

		/// <summary>
		/// `XV̎s(ACe}Ɏs)
		/// </summary>
		public void EndUpdate()
		{
			//}[NACRP\ĂȂƎɍŏɂȂĂ܂悤Ȃ̂ŁA
			//IɒACR̕ݒ肵Ă
			this.listView.Columns[(int)Column.Mark].Width = 18;
			this.listView.EndUpdate();
		}

	}//end class

	/// <summary>
	/// XbhXg^Cv\EnumiQ̃XgzigumõXg\j
	/// </summary>
	public enum BbsType {
		Zigumo = 0,
		Bbs2ch = 1,
	}

	/// <summary>
	/// eڂ\enum
	/// </summary>
	public enum Column {
		Mark = 0,
		Number = 1,
		Title = 2,
		Resnum = 3,
		LastResnum = 4,
		LastUpdate = 5,
		StartDate = 6,
		Category = 7,
		ID = 8,
	}
}
