/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: ReceivePongCommand.cs,v 1.5 2003/04/25 03:06:04 hoge-taicho Exp $
 * 
 */

using System;

using Zigumo.MessageObject;
using Zigumo.Model;
using Zigumo.Network;

namespace Zigumo.CommandObject
{
	/// <summary>
	/// pongR}h
	/// </summary>
	public class ReceivePongCommand : Zigumo.CommandObject.ControllerCommand
	{
		/// <summary>
		/// ̃R}h𔭍sP2PRlNVւ̎Q
		/// </summary>
		private P2PConnection p2pConnection;
		/// <summary>
		/// MbZ[W
		/// </summary>
		private PongMessage pong;

		public ReceivePongCommand(P2PConnection p2pCon, PongMessage msg) {
			p2pConnection = p2pCon;
			pong = msg;
		}

		/// <summary>
		/// pongbZ[WMꍇ͎̕@ɂďs
		/// 1.MpongbZ[W̃bZ[WIDƓpingbZ[WLbVɓo^Ă邩
		/// 2.LbVɓo^ĂꍇApingbZ[W͎̔ŝǂ
		/// 3.̔ŝł΁AMpongbZ[Ŵ͎̂̂߁Apong̓e
		/// 4.̔ŝłȂ΁ApingbZ[W𔭍sT[ogɑ΂jLXgŕԐM
		/// </summary>
		public override void Execute() {
			if(pong.TTL == 0)//TTLɃ[Ȃ珈Ȃ
				return;

			//connectionManager.AddServentInfo(new Servent(pong.Address, pong.Port, DateTime.Now.ToString());

			//ǂ̃RlNVɑ΂ĕԐM邩LbV`FbN
			ConnectionManager.MessageCacheData msgCacheData = connectionManager.GetCache(pong.MessageIDToGuid);
			if(msgCacheData != null) {//LbVɃbZ[WIDo^Ăꍇ̂ݏ
				if(msgCacheData.MessageType == (int)MessageType.Ping) {	//ALbVĂbZ[WpingbZ[W̏ꍇ̂ݏ
					//ߋɃLbVĂpingbZ[W̔ŝǂ
					//`FbNA̔ŝł΁ApongbZ[WƂ
					//pongB̔ŝłȂ΁ApongpingsɃjLXg
					//őԂB
					if(msgCacheData.SelfFag) {
						//ւpongbZ[W̏
					} else {
						//ȊÔւpongbZ[W̏ꍇ
						//pingMɁApongbZ[WjLXgőԂB
						pong.TTL--;
						pong.Hops++;

						if(pong.TTL > 0) {//TTL>0̏ꍇ̂݃bZ[W𒆌p
							//bZ[Wp
							connectionManager.SendMessage(pong, msgCacheData.P2PConnectionID, true);//ping𑗐MĂT[ogɃjLXg
						}
					}
				}
			}//end if
		}//end Execute
	}
}
