/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: Servent.cs,v 1.10 2003/04/25 03:06:50 hoge-taicho Exp $
 * 
 */

using System;
using System.Net;
using System.Windows.Forms;

using Zigumo.Network;

namespace Zigumo.Model
{
	/// <summary>
	/// T[ogNX
	/// </summary>
	public class Servent : IPEndPoint
	{
		/// <summary>
		/// ̃T[ogƂ̐ڑɎgpĂP2PRlNVւ̎Q
		/// </summary>
		private P2PConnection p2pConnection = null;
		/// <summary>
		/// ̃T[ogmFꂽŏI
		/// </summary>
		private DateTime dateTime = new DateTime();
		/// <summary>
		/// ̃T[og֐ڑł邩
		/// ̃|[g󂢂Ă邩ǂsȎfalseȊOtrue
		/// </summary>
		private bool connectionEnabledFlag = true;

		/// <summary>
		/// ̃T[ogƂ̐ڑɎgpĂP2PRlNVւ̎QƂւ̃vpeB
		/// </summary>
		public P2PConnection P2PConnection {
			get {
				return p2pConnection;
			}
			set {
				p2pConnection = value;
			}
		}
		/// <summary>
		/// ̃T[ogmFꂽŏĨvpeB
		/// </summary>
		public DateTime DateTime {
			get {
				return dateTime;
			}
			set {
				dateTime = value;
			}
		}
		
		/// <summary>
		/// ̃T[og֐ڑł邩ǂ̃vpeB
		/// trueȂڑł
		/// </summary>
		public bool ConnectionEnabledFlag {
			get {
				return connectionEnabledFlag;
			}
			set {
				connectionEnabledFlag = value;
			}
		}

		public Servent(IPEndPoint ipEndPoint, DateTime dt) : this(ipEndPoint.Address, ipEndPoint.Port, dt) {
		}

		public Servent(IPEndPoint ipEndPoint) : this(ipEndPoint.Address, ipEndPoint.Port) {
		}

		public Servent(IPAddress ip, int port, DateTime dt) : this(ip, port) {
			dateTime = dt;
		}

		public Servent(IPAddress ip, int port) : base(ip, port) {
		}

		/// <summary>
		/// T[ogNX̓eListViewItemNXɕϊ郁\bh
		/// </summary>
		/// <returns></returns>
		public ListViewItem GetListViewItem() {
			ListViewItem item = new ListViewItem();
			item.Tag = this;
			item.Text = this.Address.ToString() + ":" + this.Port.ToString();
			string strCon = "";
			if(p2pConnection != null) {
				try {//null`FbN͏LifłĂ邪A}`Xbĥ߈ꉞtry catchg
					strCon = p2pConnection.ConTypeToString;
				} catch(NullReferenceException e) {
					Console.WriteLine(e);
					Console.WriteLine(e.StackTrace);
				}
			}
			item.SubItems.Add(strCon);
			item.SubItems.Add(dateTime.ToString("yyyy-MM-dd HH:mm:ss"));
			item.SubItems.Add("");
			
			return item;
		}
	}
}
