/*
 * 
 * P2P anonymous BBS system zigumo
 * website:http://www.zigumo.org/
 * e-mail:hoge@zigumo.org
 *
 * Copyright (C) 2002 hoge-taicho
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * $Id: P2PListenerThread.cs,v 1.4 2003/04/25 03:07:00 hoge-taicho Exp $
 * 
 */

using System;

using Zigumo.CommandObject;
using Zigumo.Network;

namespace Zigumo.Network
{
	/// <summary>
	/// P2PpXi[Xbh
	/// </summary>
	public class P2PListenerThread : Zigumo.Network.AbstractListenerThread
	{
		/// <summary>
		/// R}hRg[ւ̎Q
		/// </summary>
		private CommandController commandController;

		public P2PListenerThread(int port) : base(port){
			commandController = CommandController.Controller;
		}

		protected override void Accept() {
			commandController.PutCommand(new ReceiveHandShakeCommand(new TcpConnection(tcpListener.AcceptSocket())));
		}
	}
}
