#!/usr/bin/perl
#===============================================================================
# zigumo server write.cgi
# ȯ:ۤĹ e-mail:hoge@zigumo.org
# zigumo κǿ http://www.zigumo.org/ 򻲾Ȥ
# ܥեȥΥ饤󥹤 GNU GPL Ǥ
# GNU GPL ξܺ٤ http://www.gnu.org/copyleft/gpl.html 򻲾Ȥ
#
# $Id: write.cgi,v 1.9 2003/05/04 09:08:54 hoge-taicho Exp $
#
# 
# mode
# category
# thread
# title
# name
# email
# text
#===============================================================================
use CGI;
use Time::Local;

require "zigumo.conf";
#=======================================
# ߼
#=======================================
#CGIμ
$query = new CGI;
$mode = $query->param('mode');
$category = $query->param('category');
$thread = $query->param('thread');
$title = $query->param('title');
$name = $query->param('name');
$email = $query->param('email');
$text = $query->param('text');

#˥
$category = sanitize($category);
$thread = sanitize($thread);
$title = sanitize($title);
$name = sanitize($name);
$email = sanitize($email);
$text = sanitize($text);

#ʸִ
$text =~ s/\r\n/<br\/>/g;
$text =~ s/\n/<br\/>/g;

#Ķѿμ
$user_agent = $ENV{'HTTP_USER_AGENT'};
$ipaddress = $ENV{'REMOTE_ADDR'};

#߻μ
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time());
$datetime = sprintf("%04d-%02d-%02d %02d:%02d:%02d", $year + 1900, ++$mon, $mday, $hour, $min, $sec);

#=======================================
# ᥤ
#=======================================
#ǥ쥯ȥ¸ߥå
&checkdir;

#åID
if($mode eq "thread") {
	$thread = `uuidgen`;#ϴĶ˹碌ѹɬ
	chomp($thread);
}

#¸ߥå
if(!(-e "$cachedir/$category/$thread")) {
	mkdir("$cachedir/$category/$thread");
}

#¾泫
open(LOCK, ">$cachedir/$category/$thread/lockfile");
flock(LOCK, 2);

#񤭹ߤåɺ
if($mode eq "thread") {
	$no = 1;
	&create_thread;
} elsif($mode eq "res") {
	#񤭹
	($title, $no) = &get_threadinfo;
	$no++;
	&write_res;
}

#¾
close(LOCK);

#=======================================
# åɺ
#=======================================
sub create_thread {
	#åɾե(info)
	open(OUT, ">$cachedir/$category/$thread/$thread.info");
	print OUT "$title\n0";
	close(OUT);
	
	#񤭹ƺ(dat)
	&write_res;
}

#=======================================
# ǥå񤭹
#=======================================
sub write_threadindex {
	my $index = $_[0];

	open(OUT, ">>$cachedir/$category/$thread/$thread.index");
	binmode(OUT);
	my $bin_index = pack("L", $index);
	print OUT $bin_index;
	close(OUT);
}

#=======================================
# MD5񤭹
#=======================================
sub write_threadmd5 {
	open(OUT, ">>$cachedir/$category/$thread/$thread.md5");
	binmode(OUT);
	
	my $val = "$no$name$email$datetime$text";
	$val =~ s/\"/\\\"/g;
	$val = `echo -n "$val" | md5sum`;#ϴĶ˹碌ѹɬ
	$val = substr($val, 0, 32);
	$val = pack("H32", $val);
	
	print OUT $val;
	close(OUT);
}

#=======================================
# 쥹񤭹
#=======================================
sub write_res {
	open(FH, ">>$cachedir/$category/$thread/$thread.dat");
	my $index = tell(FH);#եν񤭹֤߰
	print FH "<res no=\"$no\" name=\"$name\" email=\"$email\" datetime=\"$datetime\">$text</res>\n";
	close(FH);
	
	#쥹No򹹿
	&update_resno;
	
	#åɥǥå򹹿
	&write_threadindex($index);
	
	#MD5(MD5)
	&write_threadmd5;
	
	#åɥꥹȤ򹹿
	&update_threadlist;
}

#=======================================
# 쥹No.
#=======================================
sub update_resno {
	#åɾ񤭹
	open(OUT, ">$cachedir/$category/$thread/$thread.info");
	print OUT "$title\n";
	print OUT $no;
	close(OUT);
}

#=======================================
# åɾ
#=======================================
sub get_threadinfo {
	open(IN, "<$cachedir/$category/$thread/$thread.info");
	my $title = <IN>;	#ܤåɥȥ
	my $no = <IN>;		#ܤ쥹No.
	close(IN);
	chomp($title);
	chomp($no);
	return ($title, $no);
}

#=======================================
# åɥꥹȹ
#=======================================
sub update_threadlist {
	#¾泫
	open(LOCK, ">$cachedir/$category/lockfile");
	flock(LOCK, 2);
	
	open(OUT, ">$cachedir/$category/$category.dat.temp");
	print OUT "<thread id=\"$thread\" title=\"$title\" rescount=\"$no\"/>\n";
	
	my $count = 1;
	if((-e "$cachedir/$category/$category.dat") && $count < $threadlist_count) {
		open(IN, "$cachedir/$category/$category.dat");
		while(<IN>) {
			my $id = get_threadid($_);
			if($id ne $thread) {
				print OUT $_;
				$count++;
				if($count >= $threadlist_count) {
					last;#롼׽λ
				}
			}
		}
	}
	close(OUT);
	
	#ȥե򥹥åɥꥹȥե˾
	rename("$cachedir/$category/$category.dat.temp", "$cachedir/$category/$category.dat");
	
	#å
	close(LOCK);
}

#=======================================
# åID
#=======================================
sub get_threadid {
	my $line = $_[0];
	my $idx = index($line, "id");
	$idx = index($line, "\"", $idx) + 1;
	my $len = index($line, "\"", $idx) - $idx;
	my $id = substr($line, $idx, $len);
	return $id;
}

#=======================================
# ǥ쥯ȥå
#=======================================
sub checkdir {
	if($category eq "" || !(-e "$cachedir/$category")) {
		&error("error 100 cache directory not found");
	}
}

#=======================================
# 顼
#=======================================
sub error {
	print "Content-Type: text/html\r\n\r\n";
	print $_[0];
	exit;
}

#=======================================
# ˥󥰴ؿ
#=======================================
sub sanitize {
	my $str = $_[0];
	$str =~ s/&/&amp;/g;         # &  &amp;
	$str =~ s/</&lt;/g;          # <  &lt;
	$str =~ s/>/&gt;/g;          # >  &gt;
	$str =~ s/"/&quot;/g;        # "  &quot;
	$str =~ s/'/&#39;/g;         # '  &#39;
	return $str;
}

#=======================================
# ֥饦ѽ
#=======================================
#ñ̻֤liveʥХȿ
#եå
#open(LOCK, ">lockfile");
#flock(LOCK, 2);

#IPɥ쥹ꥹɤ߹
#open(IN, "<$category.dat");
#$count = 0;
#while(<IN>) {
#	$count++;
#	$data = $_;
#}
#close(IN);

#close(LOCK);

#֤η׻
#if($count > 0) {
#	$sec = substr($data, 17, 2);
#	$min = substr($data, 14, 2);
#	$hour = substr($data, 11, 2);
#	$mday = substr($data, 8, 2);
#	$mon = substr($data, 5, 2) - 1;
#	$year = substr($data, 0, 4) - 1900;
#	$time = timelocal($sec, $min, $hour, $mday, $mon, $year);
#	$time = int((time() - $time) / 3600 * 100) / 100;
#} else {
#	$time = 0;
#}

#HTML
print "Content-Type: text/html\r\n\r\n";
print "<html>\n";
print "<head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=euc-jp\">\n";
print "<title>zigumo test server</title></head>\n";
print "<body>\n";
print "mode=$mode<br>\n";
print "category=$category<br>\n";
print "title=$title<br>\n";
print "name=$name<br>\n";
print "email=$email<br>\n";
print "text=...<br>$text<br>\n";
print "<br>\n";
print "<a href=\"http://192.168.0.10/zigumo/test_write.html\">...</a>\n";
print "</body>\n";
print "</html>\n";

